local addonInfo, privateVars = ...

if nkShopCalc ~= nil then return end
nkShopCalc = {}

privateVars.internal = {}

privateVars.uiElements = {}
privateVars.uiElements.context = UI.CreateContext("nkShopCalc")
privateVars.uiElements.context:SetStrata ('dialog')

function privateVars.internal.main(_, addon)

	if addon == addonInfo.identifier then
		
		table.insert(Command.Slash.Register("nkCalc"), {privateVars.internal.commandHandler, "nkShopCalc", "config"})
		
		privateVars.currency = {}
		
		if nkPanel ~= nil then
      privateVars.uiElements.ui = nkShopCalc.nkPanelPlugin()
      nkPanel.api.registerPlugin('nkShopCalc', privateVars.uiElements.ui)
    else    
      privateVars.uiElements.ui = privateVars.internal.ui()
      local items = { { label = "Show window", callBack = function () nkSPCSetup.visible = true; privateVars.uiElements.ui:SetVisible(true) end} }     
      EnKai.manager.init('nkShopCalc', items, nil)
    end
				
		EnKai.version.init(addonInfo.toc.Identifier, addonInfo.toc.Version)
			
	end
	
end

function privateVars.internal.settingsHandler(_, addon) 

	if addon == addonInfo.identifier then
	
		if nkSPCSetup == nil then
			nkSPCSetup = { xpos = 800, ypos = 200, autoclose = true, dragable = true, currency = "EUR", defaultPackage = 20, visible = true}
		end		
		
		-- V1.0.3 configuration change
		
		if nkSPCSetup.visible == nil then nkSPCSetup.visible = true end
	end
						
end

function privateVars.internal.commandHandler(commandline)

	if privateVars.uiElements.ui:GetVisible() == true then
		privateVars.uiElements.ui:SetVisible(false)
		nkSPCSetup.visible = false
	else
		privateVars.uiElements.ui:SetVisible(true)
		nkSPCSetup.visible = true
	end
		
end

Command.Event.Attach(Event.Addon.Load.End, privateVars.internal.main, "privateVars.internal.Addon.Load.End")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, privateVars.internal.settingsHandler, "privateVars.internal.SavedVariables.Load.End")

--------------------------------------------------------------------------------------------------------------------------------------------

function privateVars.internal.ui ()

	local name = 'nkShopCalc'

	local ui = EnKai.uiCreateFrame("nkWindowElement", name .. ".ui", privateVars.uiElements.context)
	ui:SetWidth(239)
	ui:SetHeight(200)
	ui:SetBackgroundColor(0, 0, 0, .6)
	ui:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nkSPCSetup.xpos, nkSPCSetup.ypos)
	ui:SetTitle(addonInfo.toc.Identifier)
	--ui:SetAutoHide(true, 5)
	ui:SetFontSize(13)
	ui:SetDragable(nkSPCSetup.dragable)
	ui:ShowMoveToggle(true)
	ui:ShowAutoHideToggle(true)
	ui:SetVisible(nkSPCSetup.visible) 
	
	Command.Event.Attach(EnKai.events[name .. '.ui'].Moved, function (_, xpos, ypos)
		nkSPCSetup.xpos = xpos
	    nkSPCSetup.ypos = ypos 
	end, name .. '.ui.Moved')
	
	Command.Event.Attach(EnKai.events[name .. '.ui'].Dragable, function (_, newFlag)		
		nkSPCSetup.dragable = newFlag
	end, name .. '.ui.Dragable')
	
	local shopPlanLabel = UI.CreateFrame("Text", name .. ".shopPlanLabel", ui:GetContent())
	shopPlanLabel:SetFontColor(1, 1, 1, 1)
	shopPlanLabel:SetFontSize(16)
	shopPlanLabel:SetEffectGlow({ offsetX = 2, offsetY = 2})
	shopPlanLabel:SetText(privateVars.langTexts.packageHeader)
	shopPlanLabel:SetPoint("TOPLEFT", ui:GetContent(), "TOPLEFT", 5, 5)	
	
	local currencySelect = EnKai.uiCreateFrame("nkCombobox", name .. '.currencySelect', ui:GetContent())
	currencySelect:SetPoint("TOPLEFT", shopPlanLabel, "BOTTOMLEFT", 0 , 5)
	currencySelect:SetWidth(175)
	currencySelect:SetLabelWidth(125)
	currencySelect:SetText(privateVars.langTexts.selectCurrency)
	currencySelect:SetHeight(16)
	currencySelect:SetSelection({{ value = "US$", label = "US$"}, { value = "EUR", label = "EUR"}, { value = "GBP", label = "GBP"}})
	currencySelect:SetSelectedValue(nkSPCSetup.currency, false)
	currencySelect:SetColor(0.925, 0.894, 0.741, 1)
	currencySelect:SetLabelColor(0.925, 0.894, 0.741, 1)
	currencySelect:SetLayer(9)
	
	local moneyValueSelect = EnKai.uiCreateFrame("nkCombobox", name .. '.moneyValueSelect', ui:GetContent())
	moneyValueSelect:SetPoint("TOPLEFT", currencySelect, "BOTTOMLEFT", 0 , 0)
	moneyValueSelect:SetWidth(175)
	moneyValueSelect:SetLabelWidth(125)
	moneyValueSelect:SetText(privateVars.langTexts.selectPackageValue)
	moneyValueSelect:SetHeight(16)
	moneyValueSelect:SetSelection({{ value = 5, label = "5",}, { value = 20, label = "20"}, { value = 50, label = "50"}, { value = 100, label = "100"}}, false)
	moneyValueSelect:SetSelectedValue(nkSPCSetup.defaultPackage, false)
	moneyValueSelect:SetColor(0.925, 0.894, 0.741, 1)
	moneyValueSelect:SetLabelColor(0.925, 0.894, 0.741, 1)
	moneyValueSelect:SetLayer(8)
	
	local pricePerDiaLabel = UI.CreateFrame("Text", name .. ".pricePerDiaLabel", ui:GetContent())
	pricePerDiaLabel:SetFontColor(0.925, 0.894, 0.741, 1)
	pricePerDiaLabel:SetFontSize(14)
	pricePerDiaLabel:SetText(privateVars.langTexts.pricePerDiamond)
	pricePerDiaLabel:SetPoint("TOPLEFT", moneyValueSelect, "BOTTOMLEFT", 0, 0)
	pricePerDiaLabel:SetWidth(125)
	
	local pricePerDia = UI.CreateFrame("Text", name .. ".pricePerDia", ui:GetContent())
	pricePerDia:SetFontColor(0.925, 0.894, 0.741, 1)
	pricePerDia:SetFontSize(14)
	pricePerDia:SetPoint("CENTERLEFT", pricePerDiaLabel, "CENTERRIGHT", 0, 0)
	pricePerDia:SetWidth(100)
	
	local calcLabel = UI.CreateFrame("Text", name .. ".calcLabel", ui:GetContent())
	calcLabel:SetFontColor(1, 1, 1, 1)
	calcLabel:SetFontSize(16)
	calcLabel:SetEffectGlow({ offsetX = 2, offsetY = 2})
	calcLabel:SetText(privateVars.langTexts.calcHeader)
	calcLabel:SetPoint("TOPLEFT", pricePerDiaLabel, "BOTTOMLEFT", 0, 5)	
	
	local diamondEditLabel = UI.CreateFrame("Text", name .. ".diamondEditLabel", ui:GetContent())
	diamondEditLabel:SetFontColor(0.925, 0.894, 0.741, 1)
	diamondEditLabel:SetFontSize(13)
	diamondEditLabel:SetText(privateVars.langTexts.diamondsToSpend)
	diamondEditLabel:SetPoint("TOPLEFT", calcLabel, "BOTTOMLEFT", 0, 5)
	diamondEditLabel:SetWidth(125)
	
	local diamondEdit = EnKai.uiCreateFrame("nkTextfield", name .. '.diamondEdit', ui:GetContent())
	diamondEdit:SetPoint("CENTERLEFT", diamondEditLabel, "CENTERRIGHT", 0, 0)
	diamondEdit:SetWidth(50)
	diamondEdit:SetHeight(22)
	diamondEdit:SetColor(0.925, 0.894, 0.741, 1)
	diamondEdit:SetText("")
	
	local priceLabel = UI.CreateFrame("Text", name .. ".priceLabel", ui:GetContent())
	priceLabel:SetFontColor(0.925, 0.894, 0.741, 1)
	priceLabel:SetFontSize(14)
	priceLabel:SetText("You'll spend")
	priceLabel:SetPoint("TOPLEFT", diamondEditLabel, "BOTTOMLEFT", 0, 5)
	priceLabel:SetWidth(125)
	
	local price = UI.CreateFrame("Text", name .. ".priceLabel", ui:GetContent())
	price:SetFontColor(1, 0, 0, 1)
	price:SetFontSize(14)
	priceLabel:SetText(privateVars.langTexts.youSpend)
	price:SetPoint("CENTERLEFT", priceLabel, "CENTERRIGHT", 0, 0)
	price:SetWidth(125)

	function ui:updateUI()
		local diaValue = 0
		if nkSPCSetup.defaultPackage == 5 then
			diaValue = 5 / 975
		elseif nkSPCSetup.defaultPackage == 20 then
			diaValue = 20 / 4220
		elseif nkSPCSetup.defaultPackage == 50 then
			diaValue = 50 / 11050
		else
			diaValue = 100 / 24050
		end
		
		pricePerDia:SetText(string.format("%s %.5f", nkSPCSetup.currency, diaValue))
		
		local toSpend = tonumber(diamondEdit:GetText())
		if toSpend == nil then toSpend = 0 end
		price:SetText(string.format("%s %.2f", nkSPCSetup.currency, toSpend * diaValue))
	end
	
	Command.Event.Attach(EnKai.events[name .. '.ui'].Closed, function ()		
		nkSPCSetup.visible = false
	end, name .. '.ui.Closed')

	Command.Event.Attach(EnKai.events[name .. '.currencySelect'].ComboChanged, function (_, newValue)
		nkSPCSetup.currency = newValue.value
		ui:updateUI()
	end, name .. '.currencySelect.ComboChanged')
	
	Command.Event.Attach(EnKai.events[name .. '.moneyValueSelect'].ComboChanged, function (_, newValue)
		nkSPCSetup.defaultPackage = newValue.value
		ui:updateUI()
	end, name .. '.moneyValueSelect.ComboChanged')
	
	Command.Event.Attach(EnKai.events[name .. '.diamondEdit'].TextfieldChanged, function (_, newValue)		
		ui:updateUI()
	end, name .. '.diamondEdit.TextfieldChanged')
	
	ui:updateUI()

	return ui
	
end