local addonInfo, privateVars = ...

function nkShopCalc.nkPanelPlugin ()

	local plugin = nkPanel.api.plugin('nkShopCalc', true, false)

	local name = 'nkShopCalc'
	
	plugin:SetTitle('Shop Calculator')
	plugin:SetThumb('nkShopCalc', 'gfx/nkPanelIcon.png')
		
	local body = plugin:CreateBody()
	
	body:SetWidth(225)
	body:SetHeight(180)

	local shopPlanLabel = UI.CreateFrame("Text", name .. ".shopPlanLabel", body)
  shopPlanLabel:SetFontColor(1, 1, 1, 1)
  shopPlanLabel:SetFontSize(16)
  shopPlanLabel:SetEffectGlow({ offsetX = 2, offsetY = 2})
  shopPlanLabel:SetText(privateVars.langTexts.packageHeader)
  shopPlanLabel:SetPoint("TOPLEFT", body, "TOPLEFT", 5, 5) 
  
  local currencySelect = EnKai.uiCreateFrame("nkCombobox", name .. '.currencySelect', body)
  currencySelect:SetPoint("TOPLEFT", shopPlanLabel, "BOTTOMLEFT", 0 , 5)
  currencySelect:SetWidth(175)
  currencySelect:SetLabelWidth(125)
  currencySelect:SetText(privateVars.langTexts.selectCurrency)
  currencySelect:SetHeight(16)
  currencySelect:SetSelection({{ value = "US$", label = "US$"}, { value = "EUR", label = "EUR"}, { value = "GBP", label = "GBP"}})
  currencySelect:SetSelectedValue(nkSPCSetup.currency, false)
  currencySelect:SetColor(0.925, 0.894, 0.741, 1)
  currencySelect:SetLabelColor(0.925, 0.894, 0.741, 1)
  currencySelect:SetLayer(9)
  
  local moneyValueSelect = EnKai.uiCreateFrame("nkCombobox", name .. '.moneyValueSelect', body)
  moneyValueSelect:SetPoint("TOPLEFT", currencySelect, "BOTTOMLEFT", 0 , 0)
  moneyValueSelect:SetWidth(175)
  moneyValueSelect:SetLabelWidth(125)
  moneyValueSelect:SetText(privateVars.langTexts.selectPackageValue)
  moneyValueSelect:SetHeight(16)
  moneyValueSelect:SetSelection({{ value = 5, label = "5",}, { value = 20, label = "20"}, { value = 50, label = "50"}, { value = 100, label = "100"}}, false)
  moneyValueSelect:SetSelectedValue(nkSPCSetup.defaultPackage, false)
  moneyValueSelect:SetColor(0.925, 0.894, 0.741, 1)
  moneyValueSelect:SetLabelColor(0.925, 0.894, 0.741, 1)
  moneyValueSelect:SetLayer(8)
  
  local pricePerDiaLabel = UI.CreateFrame("Text", name .. ".pricePerDiaLabel", body)
  pricePerDiaLabel:SetFontColor(0.925, 0.894, 0.741, 1)
  pricePerDiaLabel:SetFontSize(14)
  pricePerDiaLabel:SetText(privateVars.langTexts.pricePerDiamond)
  pricePerDiaLabel:SetPoint("TOPLEFT", moneyValueSelect, "BOTTOMLEFT", 0, 0)
  pricePerDiaLabel:SetWidth(125)
  
  local pricePerDia = UI.CreateFrame("Text", name .. ".pricePerDia", body)
  pricePerDia:SetFontColor(0.925, 0.894, 0.741, 1)
  pricePerDia:SetFontSize(14)
  pricePerDia:SetPoint("CENTERLEFT", pricePerDiaLabel, "CENTERRIGHT", 0, 0)
  pricePerDia:SetWidth(100)
  
  local calcLabel = UI.CreateFrame("Text", name .. ".calcLabel", body)
  calcLabel:SetFontColor(1, 1, 1, 1)
  calcLabel:SetFontSize(16)
  calcLabel:SetEffectGlow({ offsetX = 2, offsetY = 2})
  calcLabel:SetText(privateVars.langTexts.calcHeader)
  calcLabel:SetPoint("TOPLEFT", pricePerDiaLabel, "BOTTOMLEFT", 0, 5) 
  
  local diamondEditLabel = UI.CreateFrame("Text", name .. ".diamondEditLabel", body)
  diamondEditLabel:SetFontColor(0.925, 0.894, 0.741, 1)
  diamondEditLabel:SetFontSize(13)
  diamondEditLabel:SetText(privateVars.langTexts.diamondsToSpend)
  diamondEditLabel:SetPoint("TOPLEFT", calcLabel, "BOTTOMLEFT", 0, 5)
  diamondEditLabel:SetWidth(125)
  
  local diamondEdit = EnKai.uiCreateFrame("nkTextfield", name .. '.diamondEdit', body)
  diamondEdit:SetPoint("CENTERLEFT", diamondEditLabel, "CENTERRIGHT", 0, 0)
  diamondEdit:SetWidth(50)
  diamondEdit:SetHeight(22)
  diamondEdit:SetColor(0.925, 0.894, 0.741, 1)
  diamondEdit:SetText("")
  
  local priceLabel = UI.CreateFrame("Text", name .. ".priceLabel", body)
  priceLabel:SetFontColor(0.925, 0.894, 0.741, 1)
  priceLabel:SetFontSize(14)
  priceLabel:SetText(privateVars.langTexts.youSpend)
  priceLabel:SetPoint("TOPLEFT", diamondEditLabel, "BOTTOMLEFT", 0, 5)
  priceLabel:SetWidth(125)
  
  local price = UI.CreateFrame("Text", name .. ".priceLabel", body)
  price:SetFontColor(1, 0, 0, 1)
  price:SetFontSize(14)
  price:SetText(string.format("%s", nkSPCSetup.currency))
  price:SetPoint("CENTERLEFT", priceLabel, "CENTERRIGHT", 0, 0)
  price:SetWidth(125)

  local function updateUI()
    local diaValue = 0
    if nkSPCSetup.defaultPackage == 5 then
      diaValue = 5 / 975
    elseif nkSPCSetup.defaultPackage == 20 then
      diaValue = 20 / 4220
    elseif nkSPCSetup.defaultPackage == 50 then
      diaValue = 50 / 11050
    else
      diaValue = 100 / 24050
    end
    
    pricePerDia:SetText(string.format("%s %.5f", nkSPCSetup.currency, diaValue))
    
    local toSpend = tonumber(diamondEdit:GetText())
    if toSpend == nil then toSpend = 0 end
    price:SetText(string.format("%s %.2f", nkSPCSetup.currency, toSpend * diaValue))
  end
  
  Command.Event.Attach(EnKai.events[name .. '.currencySelect'].ComboChanged, function (_, newValue)
    nkSPCSetup.currency = newValue.value
    updateUI()
  end, name .. '.currencySelect.ComboChanged')
  
  Command.Event.Attach(EnKai.events[name .. '.moneyValueSelect'].ComboChanged, function (_, newValue)
    nkSPCSetup.defaultPackage = newValue.value
    updateUI()
  end, name .. '.moneyValueSelect.ComboChanged')
  
  Command.Event.Attach(EnKai.events[name .. '.diamondEdit'].TextfieldChanged, function (_, newValue)    
    updateUI()
  end, name .. '.diamondEdit.TextfieldChanged')
  
  updateUI()

	return plugin

end